=== debian/changelog ===
cemu (2.0-0) unstable; urgency=low

  * Major core and GUI improvements: USB transfers, HW rev M+ support,
  massive LCD emulation improvements, TI-Basic debugging...
  See GitHub release note for more information.

 -- Adrien Bertrand <bertrand.adrien@gmail.com>  Sat, 22 Jun 2019 15:12:30 +0800

cemu (1.3-0) unstable; urgency=low

  * Several improvements, bugfixes, minor additions (see GitHub)

 -- Adrien Bertrand <bertrand.adrien@gmail.com>  Sat, 22 Jun 2019 15:12:30 +0800

cemu (1.2-0) unstable; urgency=low

  * Several improvements, bugfixes, minor additions (see GitHub)

 -- Adrien Bertrand <bertrand.adrien@gmail.com>  Tue, 11 Dec 2018 00:03:40 +0800

cemu (1.1.1-0) unstable; urgency=low

  * Minor update (update check issue fixed)

 -- Adrien Bertrand <bertrand.adrien@gmail.com>  Sat, 2 Sep 2018 04:03:40 +0800

cemu (1.1-0) unstable; urgency=low

  * Update to v1.1. Many improvements, bugfixes, and minor additions.
    See https://github.com/CE-Programming/CEmu/releases/v1.1

 -- Adrien Bertrand <bertrand.adrien@gmail.com>  Sat, 25 Aug 2018 14:24:20 +0800

cemu (1.0-0) unstable; urgency=low

  * Initial release

 -- Adrien Bertrand <bertrand.adrien@gmail.com>  Sat, 20 Jan 2018 18:16:20 +0100
