=== debian/control ===
Source: cemu
Section: devel
Priority: optional
Maintainer: Adrien Bertrand <bertrand.adrien@gmail.com>
Homepage: https://github.com/CE-Programming/CEmu
Build-Depends: automake, autoconf, libtool, pkg-config, debhelper (>= 9), qtbase5-dev (>= 5.7), qtdeclarative5-dev, qttools5-dev, qttools5-dev-tools, zlib1g-dev, libarchive-dev

Package: cemu
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Homepage: https://github.com/CE-Programming/CEmu
Description: TI-84 Plus CE / TI-83 Premium CE emulator
 Third-party multi-platform emulator of the eZ80-based TI-CE series calculators
